<?php
	/*
     LogzMon 1.4, Log Viewer and Monitor, AddOn SMTPMAIL
     Copyright (C) 2007 methodica, Hans E. Herger

     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation, version 3 of the License.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
     The author may UNDER NO CIRCUMSTANCES BE MADE LIABLE FOR ANY
     CONSEQUENCES OF USING THE PROGRAM. IF THIS WAIVER OF ALL LIABILITY
     CONTRADICTS THE LAW WHERE YOU INTEND TO USE THE PROGRAM ITS USE IS
     STRICTLY PROHIBITED.
     See the GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program.  If not, see <http://www.gnu.org/licenses/>.
	*/

 	function send_smtpmail($par='',$pat='(.*)',$msg='',$line='',$file='')
	{
	//  COFIGURATIN BEGIN ----------------------------------------
		$smtpServer = "mail.yourdomain.com";
		$port = "25";
		$timeout = "30";
		$username = "youraccount";  // your mail account
		$password = "yourpassword"; // password for your mail account
		$localhost = $_SERVER['REMOTE_ADDR']; //requires a real ip
	//  COFIGURATIN END -------------------------------------------


		$params = explode('|',$par);
		$fromn = $params[0];
		$frome = $params[1];
		$ton   = $params[2];
		$toe   = $params[3];
		$sbj   = $params[4];
		$regex = '/'.$pat.'/s';
		$regs = array();
		ereg($pat, $line, $regs);
		preg_match($regex, $line, $regs);
		for ($i = 0; $i < count($regs); $i++) { $rg = '$'.$i; $msg = str_replace($rg, $regs[$i], $msg); }
		$msg = str_replace('$file', $file, $msg);
		echo "<p><span style=\"color:#ffffff; background-color:#666666; font-weight:bold;\">&lt;SMTPMAIL&gt;</span>&nbsp;$sbj: $msg</p>";

		// Send subject and text via smtp mail
		$msg = str_replace('$line', $line, $msg);
		$msg = str_replace('\r',"\r",$msg);
		$msg = str_replace('\n',"\n",$msg);

		if(strtoupper(substr(PHP_OS,0,3)=='WIN')){
			$newLine="\r\n";
		}elseif(strtoupper(substr(PHP_OS,0,3)=='MAC')){
			$newLine="\r";
		}else{
			$newLine="\n";
		}
		$ok = 1;

		while ($ok) {
			//connect to the host and port
			$smtpConnect = fsockopen($smtpServer, $port, $errno, $errstr, $timeout);
			$smtpResponse = fgets($smtpConnect, 4096);
			if(empty($smtpConnect)) {
	   			echo "Failed to connect: $smtpResponse";
				break;
			}

			//you have to say HELO again after TLS is started
			fputs($smtpConnect, "HELO $localhost". $newLine);
			$smtpResponse = fgets($smtpConnect, 4096);

			if (strlen($username)>0) {
				//request for auth login
				fputs($smtpConnect,"AUTH LOGIN" . $newLine);
				$smtpResponse = fgets($smtpConnect, 4096);

				//send the username
				fputs($smtpConnect, base64_encode($username) . $newLine);
				$smtpResponse = fgets($smtpConnect, 4096);

				//send the password
				fputs($smtpConnect, base64_encode($password) . $newLine);
				$smtpResponse = fgets($smtpConnect, 4096);
			}

			//email from
			fputs($smtpConnect, "MAIL FROM: <$frome>" . $newLine);
			$smtpResponse = fgets($smtpConnect, 4096);

			//email to
			fputs($smtpConnect, "RCPT TO: <$toe>" . $newLine);
			$smtpResponse = fgets($smtpConnect, 4096);

			//the email
			fputs($smtpConnect, "DATA" . $newLine);
			$smtpResponse = fgets($smtpConnect, 4096);

			//construct headers
			$headers = "MIME-Version: 1.0" . $newLine;
			$headers .= "Content-type: text/plain; charset=iso-8859-1" . $newLine;
			$headers .= "To: $ton <$toe>" . $newLine;
			$headers .= "From: $fromn <$frome>" . $newLine;
			$headers .= "Date: " . date("r") . $newLine;


			//observe the . after the newline, it signals the end of message
			fputs($smtpConnect, "To: $toe\r\nFrom: $frome\r\nSubject: $sbj\r\n$headers\r\n\r\n$msg\r\n.\r\n");
			$smtpResponse = fgets($smtpConnect, 4096);

			// say goodbye
			fputs($smtpConnect,"QUIT" . $newLine);
			$smtpResponse = fgets($smtpConnect, 4096);
			fclose($smtpConnect);

			return 0;
			break;
		} // while ($ok);
		return -1;

	} // function send_smtpmail...
?>
