<?php
	/*
     LogzMon 1.4, Log Viewer and Monitor, AddOn SMSCLICK
     Note: You need to have an account with www.clickatell.com to use this AddOn

     Copyright (C) 2007 methodica, Hans E. Herger

     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation, version 3 of the License.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
     The author may UNDER NO CIRCUMSTANCES BE MADE LIABLE FOR ANY
     CONSEQUENCES OF USING THE PROGRAM. IF THIS WAIVER OF ALL LIABILITY
     CONTRADICTS THE LAW WHERE YOU INTEND TO USE THE PROGRAM ITS USE IS
     STRICTLY PROHIBITED.
     See the GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program.  If not, see <http://www.gnu.org/licenses/>.
	Copyright (C) 2007  methodica, Hans E. Herger
	*/

 	function send_smsclick($par='',$pat='(.*)',$msg='',$line='',$file='')
	{
	//  COFIGURATION BEGIN ----------------------------------------
		$urltpl  = '$proto://api.clickatell.com/http/sendmsg?api_id=$apiid&user=$user&password=$password&to=$smsto&from=$smsfrom&callback=$callback&concat=1&text=$msg';
		$apiid   = '1234567';   // HTTP API id.
		$user    = 'youruserid'; // Clickatell account user ID.
		$password= 'yourpassword'; // Clickatell account password.
		$smsto   = '';          // Mobile phone number to send SMS to.
		$smsfrom = '';          // Sender identification, default: "LogzMon".
		$callback= '1';         // Callback from Clickatell wanted. 1=YES, 0=No
		                        // (Callback URL must be configured with account).
	//  COFIGURATION END -------------------------------------------

        // Use https protocol if wrapper is available, use http protocol else.
        $proto = 'http';
        $wrappers = stream_get_wrappers();
        foreach ($wrappers as $wrapper) { if ($wrapper === 'https') { $proto = $wrapper; break; } }

		// Get parameters from user config
		$params = explode('|',$par);
		$smsfrom = (isset($params[0]))?$params[0]:'LogzMon';
		$smsto   = (isset($params[1]))?$params[1]:'';

		$ok = 1;

		while ($ok) {
		    if (empty($smsto)) { break; }

		    // Prepare message
			$regex = '/'.$pat.'/s';
			$regs = array();
			ereg($pat, $line, $regs);
			preg_match($regex, $line, $regs);
			for ($i = 0; $i < count($regs); $i++) { $rg = '$'.$i; $msg = str_replace($rg, $regs[$i], $msg); }
			if (empty($msg)) { break; }
			$msg = str_replace('$file', $file, $msg);
			$msgx = $msg;
			$msg = str_replace('$line', $line, $msg);
			$msg = str_replace('\r',"\r",$msg);
			$msg = str_replace('\n',"\n",$msg);

			// Prepare Request
			$url = str_replace("\$proto",$proto,$urltpl);
			$url = str_replace("\$apiid",rawurlencode($apiid),$url);
			$url = str_replace("\$user",rawurlencode($user),$url);
			$url = str_replace("\$password",rawurlencode($password),$url);
			$url = str_replace("\$smsto",rawurlencode($smsto),$url);
			$url = str_replace("\$smsfrom",rawurlencode($smsfrom),$url);
			$url = str_replace("\$callback",rawurlencode($callback),$url);
			$url = str_replace("\$msg",rawurlencode($msg),$url);

			// Send request
			$fp = fopen($url, "r");
			if ($fp) {
				// We had success
				$result = '';
				while ($buffer = fgets($fp, 1024)) { $result .= $buffer; }
				fclose($fp);
				echo "<p><span style=\"color:#ffffff; background-color:#666666; font-weight:bold;\">&lt;SMSCLICK&gt;</span>&nbsp;$msgx [$smsfrom &raquo; $smsto] -&gt; $result</p>";
			} else {
				// We failed
				echo "ERROR: could not call Clickatell server.";
				break;
			}
			return 0;
			break;
		} // while ($ok);
		return -1;

	} // function send_smsclick...
?>
