<?php

    /*
     LogzMon 1.4, Log Viewer and Monitor, Sample Configuration File
     Copyright (C) 2007 methodica, Hans E. Herger

     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation, version 3 of the License.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
     The author may UNDER NO CIRCUMSTANCES BE MADE LIABLE FOR ANY
     CONSEQUENCES OF USING THE PROGRAM. IF THIS WAIVER OF ALL LIABILITY
     CONTRADICTS THE LAW WHERE YOU INTEND TO USE THE PROGRAM ITS USE IS
     STRICTLY PROHIBITED.
     See the GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program.  If not, see <http://www.gnu.org/licenses/>.
    */

//	if ($user=='ADMINISTRATOR.YOURDOMAIN.COM') {

		$logfiles = array (
		  array ('D:\yourhost.yourdomain.com\logs\speciallogs.txt','(special)'),
		);

		$logdirs = array (
		  array ('X:\www.yourdomain.com\logs',''),
		  array ('X:\www2.yourdomain.com\logs','(www2)'),
		  array ('C:\Program Files\Syslogd\Logs','(syslog)'),
		);

		$archivedirs = array (
		  array ('X:\www.yourdomain.com\logs\archive',''),
		  array ('X:\www2.yoourdomain.com\logs\archive','www2'),
		);

		define('web_crawlers','Googlebot/|SurveyBot/|msnbot/|msnbot-media/|Yahoo! Slurp|http://irl\.cs\.tamu\.edu/crawler|Ask Jeeves/Teoma|Pingdom |VoilaBot |"Yahoo-MMCrawler/|"psbot/|Gecko/.* Minefield/|"search.ch V|Twiceler-|Snoopy v|Googlebot-Image/|"Seekbot/|Gigabot/|http://majestic12.co.uk/bot.php|girafa.com|"UltraSpider3000/|"http://www.suchfuchs.ch/new_detail.asp?|"GET /robots.txt |"http://www.ottosuch.de/index.php"|"ia_archiver');
		define('web_stats','"http://www.netcraft.com/survey/|"West Wind Internet Protocols |');

		$filters = array (
		  array ('/_heartbeat\.htm|/favicon.ico |/img/|/scr/|/css/','hide',''),
		);

		$filterset = array (

		  array ('.*access\.log',
			  array (web_crawlers,'#0000bb',''),
			  array (web_stats,'#00bb00',''),
			  array (' "POST .*/cgi-bin/mail\.cgi\?.* HTTP','#ffffff','#c00000'),
			  array ('HTTP/.*" 401 401 ','#663300','','smtpmail_1|syslog_1|sms_1'),
			  array ('HTTP/.*" 4[0-9]{2} |HTTP/.*" 5[0-9]{2} ','','#ffeecc'),
			  array ('update_currencies\.php\?| Currencies updated','#000000','#ffff66'),
			  array ('logviewer\.php\?mode=updatecheck','#990000','#ffffcc'),
			  array (' "http://www.google\.|"http://search\.live\.','#bb0000',''),
			  array ('/_heartbeat\.htm|/favicon.ico |/img/|/scr/|/css/','hide',''),
			  array ('"GET /admin.*|"POST /admin.*|"GET /gallery/|"POST /gallery/','#909090',''),
			  array ('"OPTIONS / HTTP/|"PROPFIND / HTTP/','','#ffffcc'),
		  ),

		  array ('.*error\.log',
		    array ('File does not exist: .*/textlets/.*\.js','#000000','#ffffdd'),
		    array ('File does not exist:','#ffffff','#cc0000'),
		    array (' user .* not found: ','#000000','#ffeecc'),
		    array ('Search, key\(s\) =','#009900','#ffffff'),
		    array ('PHP Parse error:','#ffffff','#cc0000'),
		    array ('This function is deprecated;','#666666','#ffffdd'),
		    array ('PHP Warning:','#000000','#ffff66'),
		    array ('PHP Notice:','#999999',''),
		    array ('client sent HTTP/.* request without hostname ','#cc0000',''),
		  ),

		  array ('.*SyslogCatchAll\..*',
			  array (' Logon error code=','#ffffff','#dd4400'),
		  ),

		);

		$actions = array (

		  array ('smtpmail_1','smtpmail',
		    	'Webmaster|webmaster@yourdomain.com|Administrator|admin@yourdomain.com|[LogMon] NOTICE',
		        '\A([\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}) (.*) 401 401',
		        'Access requested to protected area from IP=$1.\n\n$line'
		  ),
		  array ('syslog_1','syslog',
		  		'23|5|www.yourhost.com|LogzMon|192.168.17.100|514',
		        '\A([\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}) (.*) 401 401',
		        'Access requested to protected area from IP=$1. $0'
		  ),
		  array ('sms_1','smsclick',
		  		'LogzMon_SSA|+49123456789',
		        '\A([\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}) (.*) 401 401',
		        'Access requested to protected area from IP=$1'
		  ),

		);

		define('logext','_LOG_TXT_');
		define('arcext','_ZIP_');
		define('host_name','www.yourdomain.com');
		define('host_name_url','http://www.yourdomain.com');
		define('language','de');
		define('refresh_interval_seconds','360');
		define('refresh_test_milliseconds','15000');
		define('size','standard');
		define('SuppressHttpLookups',false);
		define('SuppressIpLookups',false);

//	}

?>
